/*************************************\
*
* Copyright (c) 1998-2001, Microsoft Corp.  All Rights Reserved.
*
* Module Name:
*
*   GdiplusFlat.h
*
* Abstract:
*
*   Private GDI+ header file.
*
\*************************************/

$ifndef _FLATAPI_INC
$define _FLATAPI_INC


$use "gdiplus.lib"




'----------------------------------------------------------------------------
' GraphicsPath APIs
'----------------------------------------------------------------------------

declare import,GdipCreatePath(GpFillMode brushMode,pointer path),GpStatus

declare import,GdipCreatePath2(pointer p, pointer p, INT i, GpFillMode m, _
	                               pointer path),GpStatus

declare import,GdipCreatePath2I(pointer p, pointer p, INT i, GpFillMode m, _
	                                pointer path),GpStatus

declare import,GdipClonePath(pointer path,pointer clonePath),GpStatus

declare import,GdipDeletePath(pointer path),GpStatus

declare import,GdipResetPath(pointer path),GpStatus

declare import,GdipGetPointCount(pointer path, pointer count),GpStatus

declare import,GdipGetPathTypes(pointer path, pointer types, INT count),GpStatus

declare import,GdipGetPathPoints(pointer p, pointer points, INT count),GpStatus

declare import,GdipGetPathPointsI(pointer p, pointer points, INT count),GpStatus

declare import,GdipGetPathFillMode(pointer path,pointer fillmode),GpStatus

declare import,GdipSetPathFillMode(pointer path, GpFillMode fillmode),GpStatus

declare import,GdipGetPathData(pointer path, pointer pathData),GpStatus

declare import,GdipStartPathFigure(pointer path),GpStatus

declare import,GdipClosePathFigure(pointer path),GpStatus

declare import,GdipClosePathFigures(pointer path),GpStatus

declare import,GdipSetPathMarker(pointer path),GpStatus

declare import,GdipClearPathMarkers(pointer path),GpStatus

declare import,GdipReversePath(pointer path),GpStatus

declare import,GdipGetPathLastPoint(pointer path, pointer lastPoint),GpStatus

declare import,GdipAddPathLine(pointer path, REAL x1, REAL y1, REAL x2, REAL y2),GpStatus

declare import,GdipAddPathLine2(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathArc(pointer path, REAL x, REAL y, REAL width, REAL height, _
	                   REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipAddPathBezier(pointer path, REAL x1, REAL y1, REAL x2, REAL y2, _
	                      REAL x3, REAL y3, REAL x4, REAL y4),GpStatus

declare import,GdipAddPathBeziers(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathCurve(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathCurve2(pointer path,pointer points, INT count, _
	                      REAL tension),GpStatus

declare import,GdipAddPathCurve3(pointer path,pointer points, INT count, _
	                      INT offset, INT numberOfSegments, REAL tension),GpStatus

declare import,GdipAddPathClosedCurve(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathClosedCurve2(pointer path,pointer points, INT count, _
	                            REAL tension),GpStatus

declare import,GdipAddPathRectangle(pointer path, REAL x, REAL y, REAL width, REAL height),GpStatus

declare import,GdipAddPathRectangles(pointer path,pointer rects, INT count),GpStatus

declare import,GdipAddPathEllipse(pointer path, REAL x, REAL y, REAL width, _
	                       REAL height),GpStatus

declare import,GdipAddPathPie(pointer path, REAL x, REAL y, REAL width, REAL height, _
	                   REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipAddPathPolygon(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathPath(pointer path, pointer addingPath, BOOL connect),GpStatus

declare import,GdipAddPathString(pointer path,pointer pstring, _
	                   INT length,pointer family, INT style, _
	                   REAL emSize,pointer layoutRect, _
	                   pointer format),GpStatus

declare import,GdipAddPathStringI(pointer path,pointer pstring, _
	                   INT length,pointer family, INT style, _
	                   REAL emSize,pointer layoutRect, _
	                   pointer format),GpStatus

declare import,GdipAddPathLineI(pointer path, INT x1, INT y1, INT x2, INT y2),GpStatus

declare import,GdipAddPathLine2I(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathArcI(pointer path, INT x, INT y, INT width, INT height, _
	                   REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipAddPathBezierI(pointer path, INT x1, INT y1, INT x2, INT y2, _
	                      INT x3, INT y3, INT x4, INT y4),GpStatus

declare import,GdipAddPathBeziersI(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathCurveI(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathCurve2I(pointer path,pointer points, INT count, _
	                      REAL tension),GpStatus

declare import,GdipAddPathCurve3I(pointer path,pointer points, INT count, _
	                      INT offset, INT numberOfSegments, REAL tension),GpStatus

declare import,GdipAddPathClosedCurveI(pointer path,pointer points, INT count),GpStatus

declare import,GdipAddPathClosedCurve2I(pointer path,pointer points, INT count, _
	                            REAL tension),GpStatus

declare import,GdipAddPathRectangleI(pointer path, INT x, INT y, INT width, INT height),GpStatus

declare import,GdipAddPathRectanglesI(pointer path,pointer rects, INT count),GpStatus

declare import,GdipAddPathEllipseI(pointer path, INT x, INT y, INT width, INT height),GpStatus

declare import,GdipAddPathPieI(pointer path, INT x, INT y, INT width, INT height, _
	                   REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipAddPathPolygonI(pointer path,pointer points, INT count),GpStatus

declare import,GdipFlattenPath(pointer path, pointer matrix, REAL flatness),GpStatus

declare import,GdipWindingModeOutline(_
	pointer path, _
	pointer matrix, _
	REAL flatness),GpStatus

declare import,GdipWidenPath(_
	pointer nativePath, _
	pointer pen, _
	pointer matrix, _
	REAL flatness),GpStatus

declare import,GdipWarpPath(pointer path, pointer matrix, _
	        pointer points, INT count, _
	       REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, _
	       WarpMode warpMode, REAL flatness),GpStatus

declare import,GdipTransformPath(pointer path, pointer matrix),GpStatus

declare import,GdipGetPathWorldBounds(pointer path, pointer bounds, _
	                  pointer matrix,pointer pen),GpStatus

declare import,GdipGetPathWorldBoundsI(pointer path, pointer bounds, _
	                   pointer matrix,pointer pen),GpStatus

declare import,GdipIsVisiblePathPoint(pointer path, REAL x, REAL y, _
	                  pointer graphics,pointer result),GpStatus

declare import,GdipIsVisiblePathPointI(pointer path, INT x, INT y, _
	                   pointer graphics,pointer result),GpStatus

declare import,GdipIsOutlineVisiblePathPoint(pointer path, REAL x, REAL y,pointer pen, _
	                         pointer graphics,pointer result),GpStatus

declare import,GdipIsOutlineVisiblePathPointI(pointer path, INT x, INT y,pointer pen, _
	                          pointer graphics,pointer result),GpStatus


'----------------------------------------------------------------------------
' PathIterator APIs
'----------------------------------------------------------------------------

declare import,GdipCreatePathIter(pointer iterator, pointer path),GpStatus

declare import,GdipDeletePathIter(pointer iterator),GpStatus

declare import,GdipPathIterNextSubpath(pointer iterator,pointer resultCount, _
	   pointer startIndex, pointer endIndex, pointer isClosed),GpStatus

declare import,GdipPathIterNextSubpathPath(pointer iterator, pointer resultCount, _
	   pointer path, pointer isClosed),GpStatus

declare import,GdipPathIterNextPathType(pointer iterator, pointer resultCount, _
	   pointer pathType, pointer startIndex, pointer endIndex),GpStatus

declare import,GdipPathIterNextMarker(pointer iterator,pointer resultCount, _
	   pointer startIndex, pointer endIndex),GpStatus

declare import,GdipPathIterNextMarkerPath(pointer iterator, pointer resultCount, _
	   pointer path),GpStatus

declare import,GdipPathIterGetCount(pointer iterator, pointer count),GpStatus

declare import,GdipPathIterGetSubpathCount(pointer iterator, pointer count),GpStatus

declare import,GdipPathIterIsValid(pointer iterator, pointer valid),GpStatus

declare import,GdipPathIterHasCurve(pointer iterator, pointer hasCurve),GpStatus

declare import,GdipPathIterRewind(pointer iterator),GpStatus

declare import,GdipPathIterEnumerate(pointer iterator, pointer resultCount, _
	pointer points,pointer types, INT count),GpStatus

declare import,GdipPathIterCopyData(pointer iterator, pointer resultCount, _
	pointer points, pointer types, INT startIndex, INT endIndex),GpStatus

'----------------------------------------------------------------------------
' Matrix APIs
'----------------------------------------------------------------------------

declare import,GdipCreateMatrix(pointer matrix),GpStatus

declare import,GdipCreateMatrix2(REAL m11, REAL m12, REAL m21, REAL m22, REAL dx, _
	                                 REAL dy,pointer matrix),GpStatus

declare import,GdipCreateMatrix3(pointer _rect,pointer dstplg, _
	                                pointer matrix),GpStatus

declare import,GdipCreateMatrix3I(pointer _rect,pointer dstplg, _
	                                 pointer matrix),GpStatus

declare import,GdipCloneMatrix(pointer matrix,pointer cloneMatrix),GpStatus

declare import,GdipDeleteMatrix(pointer matrix),GpStatus

declare import,GdipSetMatrixElements(pointer matrix, REAL m11, REAL m12, REAL m21, REAL m22, _
	                 REAL dx, REAL dy),GpStatus

declare import,GdipMultiplyMatrix(pointer matrix, pointer matrix2, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipTranslateMatrix(pointer matrix, REAL offsetX, REAL offsetY, _
	               GpMatrixOrder order),GpStatus

declare import,GdipScaleMatrix(pointer matrix, REAL scaleX, REAL scaleY, _
	           GpMatrixOrder order),GpStatus

declare import,GdipRotateMatrix(pointer matrix, REAL angle, GpMatrixOrder order),GpStatus

declare import,GdipShearMatrix(pointer matrix, REAL shearX, REAL shearY, _
	           GpMatrixOrder order),GpStatus

declare import,GdipInvertMatrix(pointer matrix),GpStatus

declare import,GdipTransformMatrixPoints(pointer matrix,pointer pts, INT count),GpStatus

declare import,GdipTransformMatrixPointsI(pointer matrix,pointer pts, INT count),GpStatus

declare import,GdipVectorTransformMatrixPoints(pointer matrix,pointer pts, _
	                                    INT count),GpStatus

declare import,GdipVectorTransformMatrixPointsI(pointer matrix,pointer pts, _
	                                    INT count),GpStatus

declare import,GdipGetMatrixElements(pointer matrix,pointer matrixOut),GpStatus

declare import,GdipIsMatrixInvertible(pointer matrix,pointer result),GpStatus

declare import,GdipIsMatrixIdentity(pointer matrix,pointer result),GpStatus

declare import,GdipIsMatrixEqual(pointer matrix,pointer matrix2, _
	             pointer result),GpStatus

'----------------------------------------------------------------------------
' Region APIs
'----------------------------------------------------------------------------

declare import,GdipCreateRegion(pointer region),GpStatus

declare import,GdipCreateRegionRect(pointer _rect,pointer region),GpStatus

declare import,GdipCreateRegionRectI(pointer _rect,pointer region),GpStatus

declare import,GdipCreateRegionPath(pointer path,pointer region),GpStatus

declare import,GdipCreateRegionRgnData(pointer regionData, INT size, _
	                   pointer region),GpStatus

declare import,GdipCreateRegionHrgn(HRGN hRgn,pointer region),GpStatus

declare import,GdipCloneRegion(pointer region,pointer cloneRegion),GpStatus

declare import,GdipDeleteRegion(pointer region),GpStatus

declare import,GdipSetInfinite(pointer region),GpStatus

declare import,GdipSetEmpty(pointer region),GpStatus

declare import,GdipCombineRegionRect(pointer region,pointer _rect, _
	                 CombineMode combineMode),GpStatus

declare import,GdipCombineRegionRectI(pointer region,pointer _rect, _
	                  CombineMode combineMode),GpStatus

declare import,GdipCombineRegionPath(pointer region,pointer path, CombineMode combineMode),GpStatus

declare import,GdipCombineRegionRegion(pointer region,pointer region2, _
	                   CombineMode combineMode),GpStatus

declare import,GdipTranslateRegion(pointer region, REAL dx, REAL dy),GpStatus

declare import,GdipTranslateRegionI(pointer region, INT dx, INT dy),GpStatus

declare import,GdipTransformRegion(pointer region,pointer matrix),GpStatus

declare import,GdipGetRegionBounds(pointer region,pointer graphics, _
	                        pointer _rect),GpStatus

declare import,GdipGetRegionBoundsI(pointer region,pointer graphics, _
	                        pointer _rect),GpStatus

declare import,GdipGetRegionHRgn(pointer region,pointer graphics,pointer hRgn),GpStatus

declare import,GdipIsEmptyRegion(pointer region,pointer graphics, _
	                      pointer result),GpStatus

declare import,GdipIsInfiniteRegion(pointer region,pointer graphics, _
	                         pointer result),GpStatus

declare import,GdipIsEqualRegion(pointer region,pointer region2, _
	                      pointer graphics,pointer result),GpStatus

declare import,GdipGetRegionDataSize(pointer region,pointer bufferSize),GpStatus

declare import,GdipGetRegionData(pointer region,pointer buffer, UINT bufferSize, _
	             pointer  sizeFilled),GpStatus

declare import,GdipIsVisibleRegionPoint(pointer region, REAL x, REAL y, _
	                             pointer graphics,pointer result),GpStatus

declare import,GdipIsVisibleRegionPointI(pointer region, INT x, INT y, _
	                             pointer graphics,pointer result),GpStatus

declare import,GdipIsVisibleRegionRect(pointer region, REAL x, REAL y, REAL width, _
	                   REAL height,pointer graphics,pointer result),GpStatus

declare import,GdipIsVisibleRegionRectI(pointer region, INT x, INT y, INT width, _
	                    INT height,pointer graphics,pointer result),GpStatus

declare import,GdipGetRegionScansCount(pointer region, pointer count, pointer matrix),GpStatus

declare import,GdipGetRegionScans(pointer region, pointer rects, pointer count, _
	             pointer matrix),GpStatus

declare import,GdipGetRegionScansI(pointer region, pointer rects, pointer count, _
	              pointer matrix),GpStatus

'----------------------------------------------------------------------------
' Brush APIs
'----------------------------------------------------------------------------

declare import,GdipCloneBrush(pointer brush,pointer cloneBrush),GpStatus

declare import,GdipDeleteBrush(pointer brush),GpStatus

declare import,GdipGetBrushType(pointer brush,pointer _type),GpStatus

'----------------------------------------------------------------------------
' HatchBrush APIs
'----------------------------------------------------------------------------

declare import,GdipCreateHatchBrush(GpHatchStyle hatchstyle, ARGB forecol, _
	                         ARGB backcol,pointer brush),GpStatus

declare import,GdipGetHatchStyle(pointer brush,pointer hatchstyle),GpStatus

declare import,GdipGetHatchForegroundColor(pointer brush, pointer forecol),GpStatus

declare import,GdipGetHatchBackgroundColor(pointer brush, pointer backcol),GpStatus

'----------------------------------------------------------------------------
' TextureBrush APIs
'----------------------------------------------------------------------------

declare import,GdipCreateTexture(pointer image, GpWrapMode wrapmode, _
	                      pointer texture),GpStatus

declare import,GdipCreateTexture2(pointer image, GpWrapMode wrapmode, REAL x, _
	              REAL y, REAL width, REAL height,pointer texture),GpStatus

declare import,GdipCreateTextureIA(pointer image, _
	                pointer imageAttributes, _
	               REAL x, REAL y, REAL width, REAL height, _
	               pointer texture),GpStatus

declare import,GdipCreateTexture2I(pointer image, GpWrapMode wrapmode, INT x, _
	               INT y, INT width, INT height,pointer texture),GpStatus

declare import,GdipCreateTextureIAI(pointer image, _
	                 pointer imageAttributes, _
	                INT x, INT y, INT width, INT height, _
	                pointer texture),GpStatus


declare import,GdipGetTextureTransform(pointer brush,pointer matrix),GpStatus

declare import,GdipSetTextureTransform(pointer brush,pointer matrix),GpStatus

declare import,GdipResetTextureTransform(pointer brush),GpStatus

declare import,GdipMultiplyTextureTransform(pointer brush,pointer matrix, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipTranslateTextureTransform(pointer brush, REAL dx, REAL dy, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipScaleTextureTransform(pointer brush, REAL sx, REAL sy, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipRotateTextureTransform(pointer brush, REAL angle, GpMatrixOrder order),GpStatus

declare import,GdipSetTextureWrapMode(pointer brush, GpWrapMode wrapmode),GpStatus

declare import,GdipGetTextureWrapMode(pointer brush,pointer wrapmode),GpStatus

declare import,GdipGetTextureImage(pointer brush,pointer image),GpStatus

'----------------------------------------------------------------------------
' SolidBrush APIs
'----------------------------------------------------------------------------

declare import,GdipCreateSolidFill(ARGB _color,pointer brush),GpStatus

declare import,GdipSetSolidFillColor(pointer brush, ARGB _color),GpStatus

declare import,GdipGetSolidFillColor(pointer brush,pointer _color),GpStatus

'----------------------------------------------------------------------------
' LineBrush APIs
'----------------------------------------------------------------------------

declare import,GdipCreateLineBrush(pointer point1, _
	                pointer point2, _
	               ARGB color1, ARGB color2, _
	               GpWrapMode wrapMode, _
	               pointer lineGradient),GpStatus

declare import,GdipCreateLineBrushI(pointer point1, _
	                 pointer point2, _
	                ARGB color1, ARGB color2, _
	                GpWrapMode wrapMode, _
	                pointer lineGradient),GpStatus

declare import,GdipCreateLineBrushFromRect(pointer _rect, _
	                       ARGB color1, ARGB color2, _
	                       LinearGradientMode mode, _
	                       GpWrapMode wrapMode, _
	                       pointer lineGradient),GpStatus

declare import,GdipCreateLineBrushFromRectI(pointer _rect, _
	                        ARGB color1, ARGB color2, _
	                        LinearGradientMode mode, _
	                        GpWrapMode wrapMode, _
	                        pointer lineGradient),GpStatus

declare import,GdipCreateLineBrushFromRectWithAngle(pointer _rect, _
	                                ARGB color1, ARGB color2, _
	                                REAL angle, _
	                                BOOL isAngleScalable, _
	                                GpWrapMode wrapMode, _
	                                pointer lineGradient),GpStatus

declare import,GdipCreateLineBrushFromRectWithAngleI(pointer _rect, _
	                                ARGB color1, ARGB color2, _
	                                REAL angle, _
	                                BOOL isAngleScalable, _
	                                GpWrapMode wrapMode, _
	                                pointer lineGradient),GpStatus

declare import,GdipSetLineColors(pointer brush, ARGB color1, ARGB color2),GpStatus

declare import,GdipGetLineColors(pointer brush, pointer colors),GpStatus

declare import,GdipGetLineRect(pointer brush,pointer _rect),GpStatus

declare import,GdipGetLineRectI(pointer brush,pointer _rect),GpStatus

declare import,GdipSetLineGammaCorrection(pointer brush, BOOL useGammaCorrection),GpStatus

declare import,GdipGetLineGammaCorrection(pointer brush,pointer useGammaCorrection),GpStatus

declare import,GdipGetLineBlendCount(pointer brush,pointer count),GpStatus

declare import,GdipGetLineBlend(pointer brush,pointer blend, pointer positions, _
	            INT count),GpStatus

declare import,GdipSetLineBlend(pointer brush,pointer blend, _
	             pointer positions, INT count),GpStatus

declare import,GdipGetLinePresetBlendCount(pointer brush,pointer count),GpStatus

declare import,GdipGetLinePresetBlend(pointer brush,pointer blend, _
	                                      pointer positions, INT count),GpStatus

declare import,GdipSetLinePresetBlend(pointer brush,pointer blend, _
	                   pointer positions, INT count),GpStatus

declare import,GdipSetLineSigmaBlend(pointer brush, REAL focus, REAL scale),GpStatus

declare import,GdipSetLineLinearBlend(pointer brush, REAL focus, REAL scale),GpStatus

declare import,GdipSetLineWrapMode(pointer brush, GpWrapMode wrapmode),GpStatus

declare import,GdipGetLineWrapMode(pointer brush,pointer wrapmode),GpStatus

declare import,GdipGetLineTransform(pointer brush,pointer matrix),GpStatus

declare import,GdipSetLineTransform(pointer brush,pointer matrix),GpStatus

declare import,GdipResetLineTransform(pointer brush),GpStatus

declare import,GdipMultiplyLineTransform(pointer brush,pointer matrix, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipTranslateLineTransform(pointer brush, REAL dx, REAL dy, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipScaleLineTransform(pointer brush, REAL sx, REAL sy, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipRotateLineTransform(pointer brush, REAL angle, _
	                   GpMatrixOrder order),GpStatus

'----------------------------------------------------------------------------
' PathGradientBrush APIs
'----------------------------------------------------------------------------

declare import,GdipCreatePathGradient(pointer points, _
	                               INT count, _
	                               GpWrapMode wrapMode, _
	                               pointer polyGradient),GpStatus

declare import,GdipCreatePathGradientI(pointer points, _
	                               INT count, _
	                               GpWrapMode wrapMode, _
	                               pointer polyGradient),GpStatus

declare import,GdipCreatePathGradientFromPath(pointer path, _
	                               pointer polyGradient),GpStatus

declare import,GdipGetPathGradientCenterColor(_
	                   pointer brush, pointer colors),GpStatus

declare import,GdipSetPathGradientCenterColor(_
	                   pointer brush, ARGB colors),GpStatus

declare import,GdipGetPathGradientSurroundColorsWithCount(_
	                   pointer brush, pointer _color, pointer count),GpStatus

declare import,GdipSetPathGradientSurroundColorsWithCount(_
	                   pointer brush, _
	                    pointer _color, pointer count),GpStatus

declare import,GdipGetPathGradientPath(pointer brush,pointer path),GpStatus

declare import,GdipSetPathGradientPath(pointer brush,pointer path),GpStatus

declare import,GdipGetPathGradientCenterPoint(_
	                   pointer brush, pointer points),GpStatus

declare import,GdipGetPathGradientCenterPointI(_
	                   pointer brush, pointer points),GpStatus

declare import,GdipSetPathGradientCenterPoint(_
	                   pointer brush, pointer points),GpStatus

declare import,GdipSetPathGradientCenterPointI(_
	                   pointer brush, pointer points),GpStatus

declare import,GdipGetPathGradientRect(pointer brush,pointer _rect),GpStatus

declare import,GdipGetPathGradientRectI(pointer brush,pointer _rect),GpStatus

declare import,GdipGetPathGradientPointCount(pointer brush, pointer count),GpStatus

declare import,GdipGetPathGradientSurroundColorCount(pointer brush, pointer count),GpStatus

declare import,GdipSetPathGradientGammaCorrection(pointer brush, _
	                              BOOL useGammaCorrection),GpStatus

declare import,GdipGetPathGradientGammaCorrection(pointer brush, _
	                              pointer useGammaCorrection),GpStatus

declare import,GdipGetPathGradientBlendCount(pointer brush, _
	                                        pointer count),GpStatus

declare import,GdipGetPathGradientBlend(pointer brush, _
	                               pointer blend,pointer positions, INT count),GpStatus

declare import,GdipSetPathGradientBlend(pointer brush, _
	            pointer blend,pointer positions, INT count),GpStatus

declare import,GdipGetPathGradientPresetBlendCount(pointer brush,pointer count),GpStatus

declare import,GdipGetPathGradientPresetBlend(pointer brush,pointer blend, _
	                                           pointer positions, INT count),GpStatus

declare import,GdipSetPathGradientPresetBlend(pointer brush,pointer blend, _
	                                    pointer positions, INT count),GpStatus

declare import,GdipSetPathGradientSigmaBlend(pointer brush, REAL focus, REAL scale),GpStatus

declare import,GdipSetPathGradientLinearBlend(pointer brush, REAL focus, REAL scale),GpStatus

declare import,GdipGetPathGradientWrapMode(pointer brush, _
	                                    pointer wrapmode),GpStatus

declare import,GdipSetPathGradientWrapMode(pointer brush, _
	                                    GpWrapMode wrapmode),GpStatus

declare import,GdipGetPathGradientTransform(pointer brush, _
	                                    pointer matrix),GpStatus

declare import,GdipSetPathGradientTransform(pointer brush, _
	                                    pointer matrix),GpStatus

declare import,GdipResetPathGradientTransform(pointer brush),GpStatus

declare import,GdipMultiplyPathGradientTransform(pointer brush, _
	                             pointer matrix, _
	                             GpMatrixOrder order),GpStatus

declare import,GdipTranslatePathGradientTransform(pointer brush, REAL dx, REAL dy, _
	                              GpMatrixOrder order),GpStatus

declare import,GdipScalePathGradientTransform(pointer brush, REAL sx, REAL sy, _
	                          GpMatrixOrder order),GpStatus

declare import,GdipRotatePathGradientTransform(pointer brush, REAL angle, _
	                           GpMatrixOrder order),GpStatus

declare import,GdipGetPathGradientFocusScales(pointer brush, pointer xScale, _
	                          pointer yScale),GpStatus

declare import,GdipSetPathGradientFocusScales(pointer brush, REAL xScale, _
	                          REAL yScale),GpStatus

'----------------------------------------------------------------------------
' Pen APIs
'----------------------------------------------------------------------------

declare import,GdipCreatePen1(ARGB _color, REAL width, GpUnit unit,pointer pen),GpStatus

declare import,GdipCreatePen2(pointer brush, REAL width, GpUnit unit, _
	                   pointer pen),GpStatus

declare import,GdipClonePen(pointer pen,pointer clonepen),GpStatus

declare import,GdipDeletePen(pointer pen),GpStatus

declare import,GdipSetPenWidth(pointer pen, REAL width),GpStatus

declare import,GdipGetPenWidth(pointer pen,pointer width),GpStatus

declare import,GdipSetPenUnit(pointer pen, GpUnit unit),GpStatus

declare import,GdipGetPenUnit(pointer pen,pointer unit),GpStatus

declare import,GdipSetPenLineCap197819(pointer pen, GpLineCap startCap, GpLineCap endCap, _
	             GpDashCap dashCap),GpStatus

declare import,GdipSetPenStartCap(pointer pen, GpLineCap startCap),GpStatus

declare import,GdipSetPenEndCap(pointer pen, GpLineCap endCap),GpStatus

declare import,GdipSetPenDashCap197819(pointer pen, GpDashCap dashCap),GpStatus

declare import,GdipGetPenStartCap(pointer pen,pointer startCap),GpStatus

declare import,GdipGetPenEndCap(pointer pen,pointer endCap),GpStatus

declare import,GdipGetPenDashCap197819(pointer pen,pointer dashCap),GpStatus

declare import,GdipSetPenLineJoin(pointer pen, GpLineJoin lineJoin),GpStatus

declare import,GdipGetPenLineJoin(pointer pen,pointer lineJoin),GpStatus

declare import,GdipSetPenCustomStartCap(pointer pen, pointer customCap),GpStatus

declare import,GdipGetPenCustomStartCap(pointer pen, pointer customCap),GpStatus

declare import,GdipSetPenCustomEndCap(pointer pen, pointer customCap),GpStatus

declare import,GdipGetPenCustomEndCap(pointer pen, pointer customCap),GpStatus

declare import,GdipSetPenMiterLimit(pointer pen, REAL miterLimit),GpStatus

declare import,GdipGetPenMiterLimit(pointer pen,pointer miterLimit),GpStatus

declare import,GdipSetPenMode(pointer pen, GpPenAlignment penMode),GpStatus

declare import,GdipGetPenMode(pointer pen,pointer penMode),GpStatus

declare import,GdipSetPenTransform(pointer pen,pointer matrix),GpStatus

declare import,GdipGetPenTransform(pointer pen,pointer matrix),GpStatus

declare import,GdipResetPenTransform(pointer pen),GpStatus

declare import,GdipMultiplyPenTransform(pointer pen,pointer matrix, _
	                      GpMatrixOrder order),GpStatus

declare import,GdipTranslatePenTransform(pointer pen, REAL dx, REAL dy, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipScalePenTransform(pointer pen, REAL sx, REAL sy, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipRotatePenTransform(pointer pen, REAL angle, GpMatrixOrder order),GpStatus

declare import,GdipSetPenColor(pointer pen, ARGB argb),GpStatus

declare import,GdipGetPenColor(pointer pen,pointer argb),GpStatus

declare import,GdipSetPenBrushFill(pointer pen,pointer brush),GpStatus

declare import,GdipGetPenBrushFill(pointer pen,pointer brush),GpStatus

declare import,GdipGetPenFillType(pointer pen, pointer _type),GpStatus

declare import,GdipGetPenDashStyle(pointer pen,pointer dashstyle),GpStatus

declare import,GdipSetPenDashStyle(pointer pen, GpDashStyle dashstyle),GpStatus

declare import,GdipGetPenDashOffset(pointer pen,pointer offset),GpStatus

declare import,GdipSetPenDashOffset(pointer pen, REAL offset),GpStatus

declare import,GdipGetPenDashCount(pointer pen,pointer count),GpStatus

declare import,GdipSetPenDashArray(pointer pen,pointer dash, INT count),GpStatus

declare import,GdipGetPenDashArray(pointer pen,pointer dash, INT count),GpStatus

declare import,GdipGetPenCompoundCount(pointer pen,pointer count),GpStatus

declare import,GdipSetPenCompoundArray(pointer pen,pointer dash, INT count),GpStatus

declare import,GdipGetPenCompoundArray(pointer pen,pointer dash, INT count),GpStatus

'----------------------------------------------------------------------------
' CustomLineCap APIs
'----------------------------------------------------------------------------

declare import,GdipCreateCustomLineCap(pointer fillPath, pointer strokePath, _
   GpLineCap baseCap, REAL baseInset,pointer customCap),GpStatus

declare import,GdipDeleteCustomLineCap(pointer customCap),GpStatus

declare import,GdipCloneCustomLineCap(pointer customCap, _
	                  pointer clonedCap),GpStatus

declare import,GdipGetCustomLineCapType(pointer customCap, _
	                  pointer capType),GpStatus

declare import,GdipSetCustomLineCapStrokeCaps(pointer customCap, _
	                          GpLineCap startCap, GpLineCap endCap),GpStatus

declare import,GdipGetCustomLineCapStrokeCaps(pointer customCap, _
	                          pointer startCap, pointer endCap),GpStatus

declare import,GdipSetCustomLineCapStrokeJoin(pointer customCap, _
	                          GpLineJoin lineJoin),GpStatus

declare import,GdipGetCustomLineCapStrokeJoin(pointer customCap, _
	                          pointer lineJoin),GpStatus

declare import,GdipSetCustomLineCapBaseCap(pointer customCap, GpLineCap baseCap),GpStatus

declare import,GdipGetCustomLineCapBaseCap(pointer customCap, pointer baseCap),GpStatus

declare import,GdipSetCustomLineCapBaseInset(pointer customCap, REAL inset),GpStatus

declare import,GdipGetCustomLineCapBaseInset(pointer customCap, pointer inset),GpStatus

declare import,GdipSetCustomLineCapWidthScale(pointer customCap, REAL widthScale),GpStatus

declare import,GdipGetCustomLineCapWidthScale(pointer customCap, pointer widthScale),GpStatus

'----------------------------------------------------------------------------
' AdjustableArrowCap APIs
'----------------------------------------------------------------------------

declare import,GdipCreateAdjustableArrowCap(REAL height, REAL width, BOOL isFilled, _
	                        pointer cap),GpStatus

declare import,GdipSetAdjustableArrowCapHeight(pointer cap, REAL height),GpStatus

declare import,GdipGetAdjustableArrowCapHeight(pointer cap, pointer height),GpStatus

declare import,GdipSetAdjustableArrowCapWidth(pointer cap, REAL width),GpStatus

declare import,GdipGetAdjustableArrowCapWidth(pointer cap, pointer width),GpStatus

declare import,GdipSetAdjustableArrowCapMiddleInset(pointer cap, _
	                                REAL middleInset),GpStatus

declare import,GdipGetAdjustableArrowCapMiddleInset(pointer cap, _
	                                pointer middleInset),GpStatus

declare import,GdipSetAdjustableArrowCapFillState(pointer cap, BOOL fillState),GpStatus

declare import,GdipGetAdjustableArrowCapFillState(pointer cap, pointer fillState),GpStatus

'----------------------------------------------------------------------------
' Image APIs
'----------------------------------------------------------------------------

declare import,GdipLoadImageFromStream(comref stream,pointer image),GpStatus

declare import,GdipLoadImageFromFile(pointer filename,pointer image),GpStatus

declare import,GdipLoadImageFromStreamICM(comref stream,pointer image),GpStatus

declare import,GdipLoadImageFromFileICM(pointer filename,pointer image),GpStatus

declare import,GdipCloneImage(pointer image,pointer cloneImage),GpStatus

declare import,GdipDisposeImage(pointer image),GpStatus

declare import,GdipSaveImageToFile(pointer image, pointer filename, _
	                pointer clsidEncoder, _
	                pointer encoderParams),GpStatus

declare import,GdipSaveImageToStream(pointer image, comref stream, _
	                  pointer clsidEncoder, _
	                  pointer encoderParams),GpStatus

declare import,GdipSaveAdd(pointer image, pointer encoderParams),GpStatus

declare import,GdipSaveAddImage(pointer image, pointer newImage, _
	             pointer encoderParams),GpStatus

declare import,GdipGetImageGraphicsContext(pointer image,pointer graphics),GpStatus

declare import,GdipGetImageBounds(pointer image,pointer srcRect,pointer srcUnit),GpStatus

declare import,GdipGetImageDimension(pointer image,pointer width,pointer height),GpStatus

declare import,GdipGetImageType(pointer image,pointer _type),GpStatus

declare import,GdipGetImageWidth(pointer image,pointer width),GpStatus

declare import,GdipGetImageHeight(pointer image,pointer height),GpStatus

declare import,GdipGetImageHorizontalResolution(pointer image,pointer resolution),GpStatus

declare import,GdipGetImageVerticalResolution(pointer image,pointer resolution),GpStatus

declare import,GdipGetImageFlags(pointer image,pointer flags),GpStatus

declare import,GdipGetImageRawFormat(pointer image,pointer format),GpStatus

declare import,GdipGetImagePixelFormat(pointer image,pointer format),GpStatus

declare import,GdipGetImageThumbnail(pointer image, UINT thumbWidth, UINT thumbHeight, _
	                 pointer thumbImage, _
	                 GetThumbnailImageAbort callback,pointer callbackData),GpStatus

declare import,GdipGetEncoderParameterListSize(pointer image, pointer clsidEncoder, _
	                           pointer size),GpStatus

declare import,GdipGetEncoderParameterList(pointer image, pointer clsidEncoder, _
	                       UINT size, pointer buffer),GpStatus

declare import,GdipImageGetFrameDimensionsCount(pointer image, pointer count),GpStatus

declare import,GdipImageGetFrameDimensionsList(pointer image, pointer dimensionIDs, _
	                           UINT count),GpStatus

declare import,GdipImageGetFrameCount(pointer image, pointer dimensionID, _
	                  pointer count),GpStatus

declare import,GdipImageSelectActiveFrame(pointer image, pointer dimensionID, _
	                      UINT frameIndex),GpStatus

declare import,GdipImageRotateFlip(pointer image, RotateFlipType rfType),GpStatus

declare import,GdipGetImagePalette(pointer image,pointer palette, INT size),GpStatus

declare import,GdipSetImagePalette(pointer image,pointer palette),GpStatus

declare import,GdipGetImagePaletteSize(pointer image,pointer size),GpStatus

declare import,GdipGetPropertyCount(pointer image, pointer numOfProperty),GpStatus

declare import,GdipGetPropertyIdList(pointer image, UINT numOfProperty, pointer list),GpStatus

declare import,GdipGetPropertyItemSize(pointer image, PROPID propId, pointer size),GpStatus

declare import,GdipGetPropertyItem(pointer image, PROPID propId,UINT propSize, _
	               pointer buffer),GpStatus

declare import,GdipGetPropertySize(pointer image, pointer totalBufferSize, _
	               pointer numProperties),GpStatus

declare import,GdipGetAllPropertyItems(pointer image, UINT totalBufferSize, _
	                   UINT numProperties, pointer allItems),GpStatus

declare import,GdipRemovePropertyItem(pointer image, PROPID propId),GpStatus

declare import,GdipSetPropertyItem(pointer image, pointer item),GpStatus

declare import,GdipFindFirstImageItem(pointer image, pointer item),GpStatus

declare import,GdipFindNextImageItem(pointer image, pointer item),GpStatus

declare import,GdipGetImageItemData(pointer image, pointer item),GpStatus

declare import,GdipImageForceValidation(pointer image),GpStatus

'----------------------------------------------------------------------------
' Bitmap APIs
'----------------------------------------------------------------------------

declare import,GdipCreateBitmapFromStream(comref stream,pointer bitmap),GpStatus

declare import,GdipCreateBitmapFromFile(pointer filename,pointer bitmap),GpStatus

declare import,GdipCreateBitmapFromStreamICM(comref stream,pointer bitmap),GpStatus

declare import,GdipCreateBitmapFromFileICM(pointer filename,pointer bitmap),GpStatus

declare import,GdipCreateBitmapFromScan0(INT width, _
	                     INT height, _
	                     INT stride, _
	                     PixelFormat format, _
	                     pointer scan0, _
	                     pointer bitmap),GpStatus

declare import,GdipCreateBitmapFromGraphics(INT width, _
	                        INT height, _
	                        pointer target, _
	                        pointer bitmap),GpStatus

declare import,GdipCreateBitmapFromDirectDrawSurface(pointer surface, _
	                                 pointer bitmap),GpStatus

declare import,GdipCreateBitmapFromGdiDib(pointer gdiBitmapInfo, _
	                      pointer gdiBitmapData, _
	                      pointer bitmap),GpStatus

declare import,GdipCreateBitmapFromHBITMAP(HBITMAP hbm, _
	                       HPALETTE hpal, _
	                       pointer bitmap),GpStatus

declare import,GdipCreateHBITMAPFromBitmap(GpBitmap bitmap, _
	                       pointer hbmReturn, _
	                       ARGB background),GpStatus

declare import,GdipCreateBitmapFromHICON(HICON hicon, _
	                     pointer bitmap),GpStatus

declare import,GdipCreateHICONFromBitmap(GpBitmap bitmap, _
	                     pointer hbmReturn),GpStatus

declare import,GdipCreateBitmapFromResource(HINSTANCE hInstance, _
	                        pointer lpBitmapName, _
	                        pointer bitmap),GpStatus

declare import,GdipCloneBitmapArea(REAL x, REAL y, REAL width, REAL height, _
	                       PixelFormat format, _
	                       pointer srcBitmap, _
	                       pointer dstBitmap),GpStatus

declare import,GdipCloneBitmapAreaI(INT x, _
	                INT y, _
	                INT width, _
	                INT height, _
	                PixelFormat format, _
	                pointer srcBitmap, _
	                pointer dstBitmap),GpStatus

declare import,GdipBitmapLockBits(GpBitmap bitmap, _
	               pointer _rect, _
	              UINT flags, _
	              PixelFormat format, _
	              pointer lockedBitmapData),GpStatus

declare import,GdipBitmapUnlockBits(GpBitmap bitmap, _
	                pointer lockedBitmapData),GpStatus

declare import,GdipBitmapGetPixel(GpBitmap bitmap, INT x, INT y,pointer _color),GpStatus

declare import,GdipBitmapSetPixel(GpBitmap bitmap, INT x, INT y, ARGB _color),GpStatus

declare import,GdipImageSetAbort(_
	pointer pImage, _
	pointer pIAbort),GpStatus

declare import,GdipGraphicsSetAbort(_
	pointer pGraphics, _
	pointer pIAbort),GpStatus

declare import,GdipBitmapConvertFormat(_
	pointer pInputBitmap, _
	PixelFormat format, _
	DitherType dithertype, _
	PaletteType palettetype, _
	pointer palette, _
	REAL alphaThresholdPercent),GpStatus

declare import,GdipInitializePalette(_
	/*out*/pointer palette, _
	PaletteType palettetype, _
	INT optimalColors, _
	BOOL useTransparentColor, _
	pointer bitmap),GpStatus

declare import,GdipBitmapApplyEffect(_
	pointer bitmap, _
	pointer effect, _
	pointer roi, _
	BOOL useAuxData, _
	pointer ppauxData, _
	pointer auxDataSize),GpStatus

declare import,GdipBitmapCreateApplyEffect(_
	pointer ppinputBitmaps, _
	INT numInputs, _
	pointer effect, _
	pointer roi, _
	pointer outputRect, _
	pointer outputBitmap, _
	BOOL useAuxData, _
	pointer auxData, _
	pointer auxDataSize),GpStatus

declare import,GdipBitmapGetHistogram(_
	pointer bitmap, _
	HistogramFormat format, _
	UINT NumberOfEntries, _
	pointer channel0, _
	pointer channel1, _
	pointer channel2, _
	pointer channel3),GpStatus

declare import,GdipBitmapGetHistogramSize(_
	HistogramFormat format, _
	/*out*/pointer NumberOfEntries),GpStatus


declare import,GdipBitmapSetResolution(pointer bitmap, REAL xdpi, REAL ydpi),GpStatus

'----------------------------------------------------------------------------
' ImageAttributes APIs
'----------------------------------------------------------------------------

declare import,GdipCreateImageAttributes(pointer imageattr),GpStatus

declare import,GdipCloneImageAttributes(pointer imageattr, _
	                    pointer cloneImageattr),GpStatus

declare import,GdipDisposeImageAttributes(pointer imageattr),GpStatus

declare import,GdipSetImageAttributesToIdentity(pointer imageattr, _
	                            ColorAdjustType _type),GpStatus
declare import,GdipResetImageAttributes(pointer imageattr, _
	                    ColorAdjustType _type),GpStatus

declare import,GdipSetImageAttributesColorMatrix(pointer imageattr, _
	                          ColorAdjustType _type, _
	                          BOOL enableFlag, _
	                           pointer colorMatrix, _
	                           pointer grayMatrix, _
	                          ColorMatrixFlags flags),GpStatus

declare import,GdipSetImageAttributesThreshold(pointer imageattr, _
	                           ColorAdjustType _type, _
	                           BOOL enableFlag, _
	                           REAL threshold),GpStatus

declare import,GdipSetImageAttributesGamma(pointer imageattr, _
	                       ColorAdjustType _type, _
	                       BOOL enableFlag, _
	                       REAL gamma),GpStatus

declare import,GdipSetImageAttributesNoOp(pointer imageattr, _
	                      ColorAdjustType _type, _
	                      BOOL enableFlag),GpStatus

declare import,GdipSetImageAttributesColorKeys(pointer imageattr, _
	                           ColorAdjustType _type, _
	                           BOOL enableFlag, _
	                           ARGB colorLow, _
	                           ARGB colorHigh),GpStatus

declare import,GdipSetImageAttributesOutputChannel(pointer imageattr, _
	                               ColorAdjustType _type, _
	                               BOOL enableFlag, _
	                               ColorChannelFlags channelFlags),GpStatus

declare import,GdipSetImageAttributesOutputChannelColorProfile(pointer imageattr, _
	                                           ColorAdjustType _type, _
	                                           BOOL enableFlag, _
	                                            pointer colorProfileFilename),GpStatus

declare import,GdipSetImageAttributesRemapTable(pointer imageattr, _
	                            ColorAdjustType _type, _
	                            BOOL enableFlag, _
	                            UINT mapSize, _
	                             pointer map),GpStatus
declare import,GdipSetImageAttributesWrapMode(_
	pointer imageAttr, _
	WrapMode wrap, _
	ARGB argb, _
	BOOL clamp),GpStatus

declare import,GdipSetImageAttributesICMMode(_
	pointer imageAttr, _
	BOOL on),GpStatus

declare import,GdipGetImageAttributesAdjustedPalette(_
	pointer imageAttr, _
	pointer  colorPalette, _
	ColorAdjustType colorAdjustType),GpStatus

'----------------------------------------------------------------------------
' Graphics APIs
'----------------------------------------------------------------------------

declare import,GdipFlush(pointer graphics, GpFlushIntention intention),GpStatus

declare import,GdipCreateFromHDC(HDC hdc,pointer graphics),GpStatus

declare import,GdipCreateFromHDC2(HDC hdc, HANDLE hDevice,pointer graphics),GpStatus

declare import,GdipCreateFromHWND(HWND hwnd,pointer graphics),GpStatus

declare import,GdipCreateFromHWNDICM(HWND hwnd,pointer graphics),GpStatus

declare import,GdipDeleteGraphics(pointer graphics),GpStatus

declare import,GdipGetDC(pointer graphics,pointer hdc),GpStatus

declare import,GdipReleaseDC(pointer graphics, HDC hdc),GpStatus

declare import,GdipSetCompositingMode(pointer graphics, CompositingMode compositingMode),GpStatus

declare import,GdipGetCompositingMode(pointer graphics,pointer compositingMode),GpStatus

declare import,GdipSetRenderingOrigin(pointer graphics, INT x, INT y),GpStatus

declare import,GdipGetRenderingOrigin(pointer graphics,pointer x,pointer y),GpStatus

declare import,GdipSetCompositingQuality(pointer graphics, _
	                     CompositingQuality compositingQuality),GpStatus

declare import,GdipGetCompositingQuality(pointer graphics, _
	                     pointer compositingQuality),GpStatus
	                     
declare import,GdipSetSmoothingMode(pointer graphics, SmoothingMode smoothingMode),GpStatus

declare import,GdipGetSmoothingMode(pointer graphics,pointer smoothingMode),GpStatus

declare import,GdipSetPixelOffsetMode(pointer graphics, PixelOffsetMode pixelOffsetMode),GpStatus

declare import,GdipGetPixelOffsetMode(pointer graphics,pointer pixelOffsetMode),GpStatus

declare import,GdipSetTextRenderingHint(pointer graphics, TextRenderingHint mode),GpStatus

declare import,GdipGetTextRenderingHint(pointer graphics,pointer mode),GpStatus

declare import,GdipSetTextContrast(pointer graphics, UINT contrast),GpStatus

declare import,GdipGetTextContrast(pointer graphics,pointer contrast),GpStatus

declare import,GdipSetInterpolationMode(pointer graphics, _
	                    InterpolationMode interpolationMode),GpStatus

declare import,GdipGetInterpolationMode(pointer graphics, _
	                    pointer interpolationMode),GpStatus

declare import,GdipSetWorldTransform(pointer graphics,pointer matrix),GpStatus

declare import,GdipResetWorldTransform(pointer graphics),GpStatus

declare import,GdipMultiplyWorldTransform(pointer graphics,pointer matrix, _
	                      GpMatrixOrder order),GpStatus

declare import,GdipTranslateWorldTransform(pointer graphics, REAL dx, REAL dy, _
	                       GpMatrixOrder order),GpStatus

declare import,GdipScaleWorldTransform(pointer graphics, REAL sx, REAL sy, _
	                   GpMatrixOrder order),GpStatus

declare import,GdipRotateWorldTransform(pointer graphics, REAL angle, _
	                    GpMatrixOrder order),GpStatus

declare import,GdipGetWorldTransform(pointer graphics,pointer matrix),GpStatus

declare import,GdipResetPageTransform(pointer graphics),GpStatus

declare import,GdipGetPageUnit(pointer graphics,pointer unit),GpStatus

declare import,GdipGetPageScale(pointer graphics,pointer scale),GpStatus

declare import,GdipSetPageUnit(pointer graphics, GpUnit unit),GpStatus

declare import,GdipSetPageScale(pointer graphics, REAL scale),GpStatus

declare import,GdipGetDpiX(pointer graphics, pointer dpi),GpStatus

declare import,GdipGetDpiY(pointer graphics, pointer dpi),GpStatus

declare import,GdipTransformPoints(pointer graphics, GpCoordinateSpace destSpace, _
	                        GpCoordinateSpace srcSpace,pointer points, _
	                        INT count),GpStatus

declare import,GdipTransformPointsI(pointer graphics, GpCoordinateSpace destSpace, _
	                        GpCoordinateSpace srcSpace,pointer points, _
	                        INT count),GpStatus

declare import,GdipGetNearestColor(pointer graphics, pointer argb),GpStatus

' Creates the Win9x Halftone Palette (even on NT) with correct Desktop colors
declare import,GdipCreateHalftonePalette(),HPALETTE

declare import,GdipDrawLine(pointer graphics,pointer pen, REAL x1, REAL y1, _
	                 REAL x2, REAL y2),GpStatus

declare import,GdipDrawLineI(pointer graphics,pointer pen, INT x1, INT y1, _
	                 INT x2, INT y2),GpStatus

declare import,GdipDrawLines(pointer graphics,pointer pen,pointer points, _
	                  INT count),GpStatus

declare import,GdipDrawLinesI(pointer graphics,pointer pen,pointer points, _
	                  INT count),GpStatus

declare import,GdipDrawArc(pointer graphics,pointer pen, REAL x, REAL y, _
	       REAL width, REAL height, REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipDrawArcI(pointer graphics,pointer pen, INT x, INT y, _
	                INT width, INT height, REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipDrawBezier(pointer graphics,pointer pen, REAL x1, REAL y1, _
	                   REAL x2, REAL y2, REAL x3, REAL y3, REAL x4, REAL y4),GpStatus

declare import,GdipDrawBezierI(pointer graphics,pointer pen, INT x1, INT y1, _
	                   INT x2, INT y2, INT x3, INT y3, INT x4, INT y4),GpStatus

declare import,GdipDrawBeziers(pointer graphics,pointer pen,pointer points, _
	                    INT count),GpStatus

declare import,GdipDrawBeziersI(pointer graphics,pointer pen,pointer points, _
	                    INT count),GpStatus

declare import,GdipDrawRectangle(pointer graphics,pointer pen, REAL x, REAL y, _
	                 REAL width, REAL height),GpStatus

declare import,GdipDrawRectangleI(pointer graphics,pointer pen, INT x, INT y, _
	                 INT width, INT height),GpStatus

declare import,GdipDrawRectangles(pointer graphics,pointer pen,pointer rects, _
	                  INT count),GpStatus

declare import,GdipDrawRectanglesI(pointer graphics,pointer pen,pointer rects, _
	                  INT count),GpStatus

declare import,GdipDrawEllipse(pointer graphics,pointer pen, REAL x, REAL y, _
	                    REAL width, REAL height),GpStatus

declare import,GdipDrawEllipseI(pointer graphics,pointer pen, INT x, INT y, _
	                    INT width, INT height),GpStatus

declare import,GdipDrawPie(pointer graphics,pointer pen, REAL x, REAL y, _
	                REAL width, REAL height, REAL startAngle, _
	       REAL sweepAngle),GpStatus

declare import,GdipDrawPieI(pointer graphics,pointer pen, INT x, INT y, _
	                INT width, INT height, REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipDrawPolygon(pointer graphics,pointer pen,pointer points, _
	                    INT count),GpStatus

declare import,GdipDrawPolygonI(pointer graphics,pointer pen,pointer points, _
	                    INT count),GpStatus

declare import,GdipDrawPath(pointer graphics,pointer pen,pointer path),GpStatus

declare import,GdipDrawCurve(pointer graphics,pointer pen,pointer points, _
	                  INT count),GpStatus

declare import,GdipDrawCurveI(pointer graphics,pointer pen,pointer points, _
	                  INT count),GpStatus

declare import,GdipDrawCurve2(pointer graphics,pointer pen,pointer points, _
	                  INT count, REAL tension),GpStatus

declare import,GdipDrawCurve2I(pointer graphics,pointer pen,pointer points, _
	                  INT count, REAL tension),GpStatus

declare import,GdipDrawCurve3(pointer graphics,pointer pen,pointer points, _
	          INT count, INT offset, INT numberOfSegments, REAL tension),GpStatus

declare import,GdipDrawCurve3I(pointer graphics,pointer pen,pointer points, _
	           INT count, INT offset, INT numberOfSegments, REAL tension),GpStatus

declare import,GdipDrawClosedCurve(pointer graphics,pointer pen, _
	                pointer points, INT count),GpStatus

declare import,GdipDrawClosedCurveI(pointer graphics,pointer pen, _
	                 pointer points, INT count),GpStatus

declare import,GdipDrawClosedCurve2(pointer graphics,pointer pen, _
	                 pointer points, INT count, REAL tension),GpStatus

declare import,GdipDrawClosedCurve2I(pointer graphics,pointer pen, _
	                  pointer points, INT count, REAL tension),GpStatus

declare import,GdipGraphicsClear(pointer graphics, ARGB _color),GpStatus

declare import,GdipFillRectangle(pointer graphics,pointer brush, REAL x, REAL y, _
	             REAL width, REAL height),GpStatus

declare import,GdipFillRectangleI(pointer graphics,pointer brush, INT x, INT y, _
	              INT width, INT height),GpStatus

declare import,GdipFillRectangles(pointer graphics,pointer brush, _
	               pointer rects, INT count),GpStatus

declare import,GdipFillRectanglesI(pointer graphics,pointer brush, _
	                pointer rects, INT count),GpStatus

declare import,GdipFillPolygon(pointer graphics,pointer brush, _
	            pointer points, INT count, GpFillMode fillMode),GpStatus

declare import,GdipFillPolygonI(pointer graphics,pointer brush, _
	pointer points, INT count, GpFillMode fillMode),GpStatus

declare import,GdipFillPolygon2(pointer graphics,pointer brush, _
	pointer points, INT count),GpStatus

declare import,GdipFillPolygon2I(pointer graphics,pointer brush, _
	pointer points, INT count),GpStatus

declare import,GdipFillEllipse(pointer graphics,pointer brush, REAL x, REAL y, _
	REAL width, REAL height),GpStatus

declare import,GdipFillEllipseI(pointer graphics,pointer brush, INT x, INT y, _
	INT width, INT height),GpStatus

declare import,GdipFillPie(pointer graphics,pointer brush, REAL x, REAL y, _
	REAL width, REAL height, REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipFillPieI(pointer graphics,pointer brush, INT x, INT y, _
	INT width, INT height, REAL startAngle, REAL sweepAngle),GpStatus

declare import,GdipFillPath(pointer graphics,pointer brush,pointer path),GpStatus

declare import,GdipFillClosedCurve(pointer graphics,pointer brush, _
	pointer points, INT count),GpStatus

declare import,GdipFillClosedCurveI(pointer graphics,pointer brush, _
	pointer points, INT count),GpStatus

declare import,GdipFillClosedCurve2(pointer graphics,pointer brush, _
	pointer points, INT count, _
	REAL tension, GpFillMode fillMode),GpStatus

declare import,GdipFillClosedCurve2I(pointer graphics,pointer brush, _
	pointer points, INT count, _
	REAL tension, GpFillMode fillMode),GpStatus

declare import,GdipFillRegion(pointer graphics,pointer brush, _
	pointer region),GpStatus

declare import,GdipDrawImageFX(_
	pointer graphics, _
	pointer image, _
	pointer source, _
	pointer xForm, _
	pointer effect, _
	pointer imageAttributes, _
	GpUnit srcUnit),GpStatus



declare import,GdipDrawImage(pointer graphics,pointer image, REAL x, REAL y),GpStatus

declare import,GdipDrawImageI(pointer graphics,pointer image, INT x, INT y),GpStatus

declare import,GdipDrawImageRect(pointer graphics,pointer image, REAL x, REAL y, _
	                      REAL width, REAL height),GpStatus

declare import,GdipDrawImageRectI(pointer graphics,pointer image, INT x, INT y, _
	                      INT width, INT height),GpStatus

declare import,GdipDrawImagePoints(pointer graphics,pointer image, _
	                         pointer dstpoints, INT count),GpStatus

declare import,GdipDrawImagePointsI(pointer graphics,pointer image, _
	                         pointer dstpoints, INT count),GpStatus

declare import,GdipDrawImagePointRect(pointer graphics,pointer image, REAL x, _
	                           REAL y, REAL srcx, REAL srcy, REAL srcwidth, _
	                           REAL srcheight, GpUnit srcUnit),GpStatus

declare import,GdipDrawImagePointRectI(pointer graphics,pointer image, INT x, _
	                           INT y, INT srcx, INT srcy, INT srcwidth, _
	                           INT srcheight, GpUnit srcUnit),GpStatus

declare import,GdipDrawImageRectRect(pointer graphics,pointer image, REAL dstx, _
	                 REAL dsty, REAL dstwidth, REAL dstheight, _
	                 REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, _
	                 GpUnit srcUnit, _
	                  pointer imageAttributes, _
	                 DrawImageAbort callback,pointer callbackData),GpStatus

declare import,GdipDrawImageRectRectI(pointer graphics,pointer image, INT dstx, _
	                  INT dsty, INT dstwidth, INT dstheight, _
	                  INT srcx, INT srcy, INT srcwidth, INT srcheight, _
	                  GpUnit srcUnit, _
	                   pointer imageAttributes, _
	                  DrawImageAbort callback,pointer callbackData),GpStatus

declare import,GdipDrawImagePointsRect(pointer graphics,pointer image, _
	                    pointer points, INT count, REAL srcx, _
	                   REAL srcy, REAL srcwidth, REAL srcheight, _
	                   GpUnit srcUnit, _
	                    pointer imageAttributes, _
	                   DrawImageAbort callback,pointer callbackData),GpStatus

declare import,GdipDrawImagePointsRectI(pointer graphics,pointer image, _
	                     pointer points, INT count, INT srcx, _
	                    INT srcy, INT srcwidth, INT srcheight, _
	                    GpUnit srcUnit, _
	                     pointer imageAttributes, _
	                    DrawImageAbort callback,pointer callbackData),GpStatus

declare import,GdipEnumerateMetafileDestPoint(_
	pointer             graphics, _
	pointer   metafile, _
	pointer     destPoint, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileDestPointI(_
	pointer             graphics, _
	pointer   metafile, _
	pointer      destPoint, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileDestRect(_
	pointer             graphics, _
	pointer   metafile, _
	pointer      destRect, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileDestRectI(_
	pointer             graphics, _
	pointer   metafile, _
	pointer       destRect, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileDestPoints(_
	pointer             graphics, _
	pointer   metafile, _
	pointer       destPoints, _
	INT                     count, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileDestPointsI(_
	pointer             graphics, _
	pointer   metafile, _
	pointer        destPoints, _
	INT                     count, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileSrcRectDestPoint(_
	pointer             graphics, _
	pointer   metafile, _
	pointer     destPoint, _
	pointer      srcRect, _
	Unit                    srcUnit, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileSrcRectDestPointI(_
	pointer             graphics, _
	pointer   metafile, _
	pointer      destPoint, _
	pointer       srcRect, _
	Unit                    srcUnit, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileSrcRectDestRect(_
	pointer             graphics, _
	pointer   metafile, _
	pointer      destRect, _
	pointer      srcRect, _
	Unit                    srcUnit, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileSrcRectDestRectI(_
	pointer             graphics, _
	pointer   metafile, _
	pointer       destRect, _
	pointer       srcRect, _
	Unit                    srcUnit, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileSrcRectDestPoints(_
	pointer             graphics, _
	pointer   metafile, _
	pointer       destPoints, _
	INT                     count, _
	pointer      srcRect, _
	Unit                    srcUnit, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipEnumerateMetafileSrcRectDestPointsI(_
	pointer             graphics, _
	pointer   metafile, _
	pointer        destPoints, _
	INT                     count, _
	pointer       srcRect, _
	Unit                    srcUnit, _
	EnumerateMetafileProc   callback, _
	pointer                   callbackData, _
	pointer      imageAttributes)

declare import,GdipPlayMetafileRecord(_
	pointer   metafile, _
	EmfPlusRecordType       recordType, _
	UINT                    flags, _
	UINT                    dataSize, _
	pointer         _data)

declare import,GdipSetClipGraphics(pointer graphics,pointer srcgraphics, _
	               CombineMode combineMode),GpStatus

declare import,GdipSetClipRect(pointer graphics, REAL x, REAL y, _
	                    REAL width, REAL height, CombineMode combineMode),GpStatus

declare import,GdipSetClipRectI(pointer graphics, INT x, INT y, _
	                    INT width, INT height, CombineMode combineMode),GpStatus

declare import,GdipSetClipPath(pointer graphics,pointer path, CombineMode combineMode),GpStatus

declare import,GdipSetClipRegion(pointer graphics,pointer region, _
	             CombineMode combineMode),GpStatus

declare import,GdipSetClipHrgn(pointer graphics, HRGN hRgn, CombineMode combineMode),GpStatus

declare import,GdipResetClip(pointer graphics),GpStatus

declare import,GdipTranslateClip(pointer graphics, REAL dx, REAL dy),GpStatus

declare import,GdipTranslateClipI(pointer graphics, INT dx, INT dy),GpStatus

declare import,GdipGetClip(pointer graphics,pointer region),GpStatus

declare import,GdipGetClipBounds(pointer graphics,pointer _rect),GpStatus

declare import,GdipGetClipBoundsI(pointer graphics,pointer _rect),GpStatus

declare import,GdipIsClipEmpty(pointer graphics,pointer result),GpStatus

declare import,GdipGetVisibleClipBounds(pointer graphics,pointer _rect),GpStatus

declare import,GdipGetVisibleClipBoundsI(pointer graphics,pointer _rect),GpStatus

declare import,GdipIsVisibleClipEmpty(pointer graphics,pointer result),GpStatus

declare import,GdipIsVisiblePoint(pointer graphics, REAL x, REAL y, _
	                      pointer result),GpStatus

declare import,GdipIsVisiblePointI(pointer graphics, INT x, INT y, _
	                      pointer result),GpStatus

declare import,GdipIsVisibleRect(pointer graphics, REAL x, REAL y, _
	                      REAL width, REAL height,pointer result),GpStatus

declare import,GdipIsVisibleRectI(pointer graphics, INT x, INT y, _
	                      INT width, INT height,pointer result),GpStatus

declare import,GdipSaveGraphics(pointer graphics,pointer state),GpStatus

declare import,GdipRestoreGraphics(pointer graphics, GraphicsState state),GpStatus

declare import,GdipBeginContainer(pointer graphics, pointer dstrect, _
	               pointer srcrect, GpUnit unit, _
	              pointer state),GpStatus

declare import,GdipBeginContainerI(pointer graphics, pointer dstrect, _
	                pointer srcrect, GpUnit unit, _
	               pointer state),GpStatus

declare import,GdipBeginContainer2(pointer graphics, pointer state),GpStatus

declare import,GdipEndContainer(pointer graphics, GraphicsContainer state),GpStatus


declare import,GdipGetMetafileHeaderFromWmf(_
	HMETAFILE           hWmf, _
	pointer      wmfPlaceableFileHeader, _
	pointer     header),GpStatus


declare import,GdipGetMetafileHeaderFromEmf(_
	HENHMETAFILE        hEmf, _
	pointer     header),GpStatus


declare import,GdipGetMetafileHeaderFromFile(_
	pointer        filename, _
	pointer     header),GpStatus


declare import,GdipGetMetafileHeaderFromStream(_
	comref            stream, _
	pointer     header),GpStatus


declare import,GdipGetMetafileHeaderFromMetafile(_
	pointer         metafile, _
	pointer     header),GpStatus


declare import,GdipGetHemfFromMetafile(_
	pointer         metafile, _
	pointer       hEmf),GpStatus

declare import,GdipCreateStreamOnFile(pointer filename, UINT access, _
	                  pointer stream),GpStatus

declare import,GdipCreateMetafileFromWmf(HMETAFILE hWmf, BOOL deleteWmf, _
	                      pointer  wmfPlaceableFileHeader, _
	                     pointer metafile),GpStatus

declare import,GdipCreateMetafileFromEmf(HENHMETAFILE hEmf, BOOL deleteEmf, _
	                     pointer metafile),GpStatus

declare import,GdipCreateMetafileFromFile(pointer _file,pointer metafile),GpStatus

declare import,GdipCreateMetafileFromWmfFile(pointer _file, _
	                          pointer  wmfPlaceableFileHeader, _
	                         pointer metafile),GpStatus

declare import,GdipCreateMetafileFromStream(comref stream,pointer metafile),GpStatus

declare import,GdipRecordMetafile(_
	HDC                 referenceHdc, _
	EmfType             _type, _
	pointer  frameRect, _
	MetafileFrameUnit   frameUnit, _
	pointer    description, _
	pointer        metafile)

declare import,GdipRecordMetafileI(_
	HDC                 referenceHdc, _
	EmfType             _type, _
	pointer   frameRect, _
	MetafileFrameUnit   frameUnit, _
	pointer    description, _
	pointer        metafile)

declare import,GdipRecordMetafileFileName(_
	pointer    fileName, _
	HDC                 referenceHdc, _
	EmfType             _type, _
	pointer  frameRect, _
	MetafileFrameUnit   frameUnit, _
	pointer    description, _
	pointer        metafile)

declare import,GdipRecordMetafileFileNameI(_
	pointer    fileName, _
	HDC                 referenceHdc, _
	EmfType             _type, _
	pointer   frameRect, _
	MetafileFrameUnit   frameUnit, _
	pointer    description, _
	pointer        metafile)

declare import,GdipRecordMetafileStream(_
	comref            stream, _
	HDC                 referenceHdc, _
	EmfType             _type, _
	pointer  frameRect, _
	MetafileFrameUnit   frameUnit, _
	pointer    description, _
	pointer        metafile)

declare import,GdipRecordMetafileStreamI(_
	comref            stream, _
	HDC                 referenceHdc, _
	EmfType             _type, _
	pointer   frameRect, _
	MetafileFrameUnit   frameUnit, _
	pointer    description, _
	pointer        metafile)

declare import,GdipSetMetafileDownLevelRasterizationLimit(_
	pointer             metafile, _
	UINT                    metafileRasterizationLimitDpi)

declare import,GdipGetMetafileDownLevelRasterizationLimit(_
	pointer   metafile, _
	pointer                   metafileRasterizationLimitDpi)

declare import,GdipGetImageDecodersSize(pointer numDecoders,pointer size),GpStatus

declare import,GdipGetImageDecoders(UINT numDecoders, _
	                UINT size, _
	                pointer decoders),GpStatus

declare import,GdipGetImageEncodersSize(pointer numEncoders,pointer size),GpStatus

declare import,GdipGetImageEncoders(UINT numEncoders, _
	                UINT size, _
	                pointer encoders),GpStatus

declare import,GdipComment(pointer graphics, UINT sizeData,pointer _data),GpStatus

'----------------------------------------------------------------------------
' FontFamily APIs
'----------------------------------------------------------------------------

declare import,GdipCreateFontFamilyFromName(pointer name, _
	                        pointer fontCollection, _
	                        pointer FontFamily),GpStatus

declare import,GdipDeleteFontFamily(pointer FontFamily),GpStatus

declare import,GdipCloneFontFamily(pointer FontFamily,pointer clonedFontFamily),GpStatus

declare import,GdipGetGenericFontFamilySansSerif(pointer nativeFamily),GpStatus

declare import,GdipGetGenericFontFamilySerif(pointer nativeFamily),GpStatus

declare import,GdipGetGenericFontFamilyMonospace(pointer nativeFamily),GpStatus


declare import,GdipGetFamilyName(_
	pointer family, _
	WCHAR                name[LF_FACESIZE], _
	LANGID               language),GpStatus

declare import,GdipIsStyleAvailable(pointer family, INT style, _
	                pointer  IsStyleAvailable),GpStatus

declare import,GdipFontCollectionEnumerable(_
	pointer fontCollection, _
	pointer graphics, _
	pointer        numFound),GpStatus

declare import, GdipFontCollectionEnumerate(_
	pointer fontCollection, _
	INT             numSought, _
	pointer   gpfamilies, _
	pointer            numFound, _
	pointer     graphics),GpStatus

declare import,GdipGetEmHeight(pointer family, INT style, _
	          pointer  EmHeight),GpStatus

declare import,GdipGetCellAscent(pointer family, INT style, _
	            pointer  CellAscent),GpStatus

declare import,GdipGetCellDescent(pointer family, INT style, _
	             pointer  CellDescent),GpStatus

declare import,GdipGetLineSpacing(pointer family, INT style, _
	             pointer  LineSpacing),GpStatus


'----------------------------------------------------------------------------
' Font APIs
'----------------------------------------------------------------------------

declare import,GdipCreateFontFromDC(_
	HDC        hdc, _
	pointer font),GpStatus

declare import,GdipCreateFontFromLogfontA(_
	HDC        hdc, _
	pointer logfont, _
	pointer font),GpStatus

declare import,GdipCreateFontFromLogfontW(_
	HDC        hdc, _
	pointer logfont, _
	pointer font),GpStatus

declare import,GdipCreateFont(_
	pointer fontFamily, _
	REAL                 emSize, _
	INT                  style, _
	Unit                 unit, _
	pointer font),GpStatus

declare import,GdipCloneFont(pointer font, pointer cloneFont),GpStatus

declare import,GdipDeleteFont(pointer font),GpStatus

declare import,GdipGetFamily(pointer font,pointer family),GpStatus

declare import,GdipGetFontStyle(pointer font,pointer style),GpStatus

declare import,GdipGetFontSize(pointer font,pointer size),GpStatus

declare import,GdipGetFontUnit(pointer font,pointer unit),GpStatus

declare import,GdipGetFontHeight(pointer font,pointer graphics, _
	             pointer height),GpStatus

declare import,GdipGetFontHeightGivenDPI(pointer font, REAL dpi,pointer height),GpStatus

declare import,GdipGetLogFontA(pointer font,pointer graphics,pointer logfontA),GpStatus

declare import,GdipGetLogFontW(pointer font,pointer graphics,pointer logfontW),GpStatus

declare import,GdipNewInstalledFontCollection(pointer fontCollection),GpStatus

declare import,GdipNewPrivateFontCollection(pointer fontCollection),GpStatus

declare import,GdipDeletePrivateFontCollection(pointer fontCollection),GpStatus

declare import,GdipGetFontCollectionFamilyCount(_
	pointer fontCollection, _
	pointer        numFound),GpStatus

declare import,GdipGetFontCollectionFamilyList(_
	pointer fontCollection, _
	INT             numSought, _
	pointer   gpfamilies, _
	pointer            numFound),GpStatus

declare import,GdipPrivateAddFontFile(_
	pointer fontCollection, _
	pointer filename),GpStatus

declare import,GdipPrivateAddMemoryFont(_
	pointer fontCollection, _
	pointer _memory, _
	INT length),GpStatus

'----------------------------------------------------------------------------
' Text APIs
'----------------------------------------------------------------------------

declare import,GdipDrawString(_
	pointer graphics, _
	pointer pstring, _
	INT length, _
	pointer font, _
	pointer layoutRect, _
	pointer stringFormat, _
	pointer brush),GpStatus

declare import,GdipMeasureString(_
	pointer graphics, _
	pointer pstring, _
	INT length, _
	pointer font, _
	pointer layoutRect, _
	pointer stringFormat, _
	pointer boundingBox, _
	pointer codepointsFitted, _
	pointer linesFilled),GpStatus


declare import,GdipMeasureCharacterRanges(_
	pointer graphics, _
	pointer pstring, _
	INT length, _
	pointer font, _
	pointer layoutRect, _
	pointer stringFormat, _
	INT regionCount, _
	pointer regions),GpStatus

declare import,GdipDrawDriverString(_
	pointer graphics, _
	pointer text, _
	INT length, _
	pointer font, _
	pointer brush, _
	pointer positions, _
	INT flags, _
	pointer matrix),GpStatus

declare import,GdipMeasureDriverString(_
	pointer graphics, _
	pointer text, _
	INT length, _
	pointer font, _
	pointer positions, _
	INT flags, _
	pointer matrix, _
	pointer boundingBox),GpStatus

'----------------------------------------------------------------------------
' String format APIs
'----------------------------------------------------------------------------

declare import,GdipCreateStringFormat(_
	INT               formatAttributes, _
	LANGID            language, _
	pointer format),GpStatus

declare import,GdipStringFormatGetGenericDefault(pointer format),GpStatus

declare import,GdipStringFormatGetGenericTypographic(pointer format),GpStatus

declare import,GdipDeleteStringFormat(pointer format),GpStatus

declare import,GdipCloneStringFormat(pointer format, _
	                pointer newFormat),GpStatus

declare import,GdipSetStringFormatFlags(pointer format, INT flags),GpStatus

declare import, GdipGetStringFormatFlags(pointer format, _
	                                        pointer flags),GpStatus

declare import,GdipSetStringFormatAlign(pointer format, StringAlignment align),GpStatus

declare import,GdipGetStringFormatAlign(pointer format, _
	                    pointer align),GpStatus

declare import,GdipSetStringFormatLineAlign(pointer format, _
	                        StringAlignment align),GpStatus

declare import,GdipGetStringFormatLineAlign(pointer format, _
	                        pointer align),GpStatus

declare import,GdipSetStringFormatTrimming(_
	pointer format, _
	StringTrimming   trimming),GpStatus

declare import,GdipGetStringFormatTrimming(_
	pointer format, _
	pointer trimming),GpStatus

declare import,GdipSetStringFormatHotkeyPrefix(pointer format, INT hotkeyPrefix),GpStatus

declare import,GdipGetStringFormatHotkeyPrefix(pointer format, _
	                           pointer hotkeyPrefix),GpStatus

declare import,GdipSetStringFormatTabStops(pointer format, REAL firstTabOffset, _
	                       INT count,pointer tabStops),GpStatus

declare import,GdipGetStringFormatTabStops(pointer format, INT count, _
	                       pointer firstTabOffset,pointer tabStops),GpStatus

declare import,GdipGetStringFormatTabStopCount(pointer format,pointer count),GpStatus

declare import,GdipSetStringFormatDigitSubstitution(pointer format, LANGID language, _
	                                StringDigitSubstitute substitute),GpStatus

declare import,GdipGetStringFormatDigitSubstitution(pointer format, _
	                                pointer language, _
	                                pointer substitute),GpStatus

declare import,GdipGetStringFormatMeasurableCharacterRangeCount(_
	pointer format, _
	pointer count),GpStatus

declare import,GdipSetStringFormatMeasurableCharacterRanges(_
	pointer format, _
	INT                         rangeCount, _
	pointer ranges),GpStatus

'----------------------------------------------------------------------------
' Cached Bitmap APIs
'----------------------------------------------------------------------------

declare import,GdipCreateCachedBitmap(_
	pointer bitmap, _
	pointer graphics, _
	pointer cachedBitmap),GpStatus

declare import,GdipDeleteCachedBitmap(pointer cachedBitmap),GpStatus

declare import,GdipDrawCachedBitmap(_
	pointer graphics, _
	pointer cachedBitmap, _
	INT x, _
	INT y),GpStatus

declare import,GdipEmfToWmfBits(_
	HENHMETAFILE hemf, _
	UINT         cbData16, _
	pointer        pData16, _
	INT          iMapMode, _
	INT          eFlags),UINT

declare import,GdipSetImageAttributesCachedBackground(_
	pointer imageattr, _
	BOOL enableFlag),GpStatus

declare import,GdipTestControl(_
	GpTestControlEnum _control, _
	pointer  param),GpStatus

declare import,GdiplusNotificationHook(_
	/*out*/pointer token),GpStatus

declare import,GdiplusNotificationUnhook(_
	ULONG_PTR token)


declare import,GdipConvertToEmfPlus(_
   pointer refGraphics, _
   pointer  metafile, _
   pointer conversionFailureFlag, _
   EmfType      emfType, _
   pointer description, _
   GpMetafile ppout_metafile),GpStatus

declare import,GdipConvertToEmfPlusToFile(_
   pointer refGraphics, _
   pointer  metafile, _
   pointer conversionFailureFlag, _
   pointer filename, _
   EmfType      emfType, _
   pointer description, _
   pointer ppout_metafile),GpStatus

declare import,GdipConvertToEmfPlusToStream(_
   pointer refGraphics, _
   pointer  metafile, _
   pointer conversionFailureFlag, _
   comref stream, _
   EmfType      emfType, _
   pointer description, _
   pointer ppout_metafile),GpStatus



$endif

