/*************************************\
*
* Copyright (c) 1998-2001, Microsoft Corp.  All Rights Reserved.
*
* Module Name:
*
*   GdiplusGpStubs.h
*
* Abstract:
*
*   Private GDI+ header file.
*
\*************************************/

$ifndef __GDIPLUSGPSTUBS_INC__
$define __GDIPLUSGPSTUBS_INC__

'---------------------------------------------------------------------------
' GDI+ classes for forward reference
'---------------------------------------------------------------------------

class Graphics
endclass
class Pen
endclass
'class Brush {}
'class Matrix {}
'class Bitmap {}
class Metafile
endclass
'class GraphicsPath {}
class PathIterator
endclass
'class Region {}
'class Image {}
'class TextureBrush {}
'class HatchBrush {}
'class SolidBrush {}
'class LinearGradientBrush {}
'class PathGradientBrush {}
'class Font {}
'class FontFamily {}
'class FontCollection {}
'class InstalledFontCollection {}
'class PrivateFontCollection {}
'class ImageAttributes {}
'class CachedBitmap {}

'---------------------------------------------------------------------------
' Private GDI+ classes for internal type checking
'---------------------------------------------------------------------------
typedef GpGraphics pointer

typedef GpBrush pointer
typedef GpTexture pointer
typedef GpSolidFill pointer
typedef GpLineGradient pointer
typedef GpPathGradient pointer
typedef GpHatch pointer

typedef GpPen pointer
typedef GpCustomLineCap pointer
typedef GpAdjustableArrowCap pointer

typedef GpImage pointer
typedef GpBitmap pointer

typedef GpMetafile pointer
typedef GpImageAttributes pointer

typedef GpPath pointer
typedef GpRegion pointer
typedef GpPathIterator pointer

typedef GpFontFamily pointer
typedef GpFont pointer
typedef GpStringFormat pointer
typedef GpFontCollection pointer
typedef GpInstalledFontCollection pointer
typedef GpPrivateFontCollection pointer

typedef GpCachedBitmap pointer

typedef GpStatus int
typedef GpFillMode FillMode
typedef GpWrapMode WrapMode
typedef GpUnit Unit
typedef GpCoordinateSpace CoordinateSpace
'typedef GpPointF PointF
'typedef GpPoint Point
'typedef GpRectF RectF
'typedef GpRect Rect
'typedef GpSizeF SizeF
typedef GpHatchStyle HatchStyle
typedef GpDashStyle DashStyle
typedef GpLineCap LineCap
typedef GpDashCap DashCap


typedef GpPenAlignment PenAlignment

typedef GpLineJoin LineJoin
typedef GpPenType PenType

'typedef GpMatrix Matrix
typedef GpBrushType BrushType
typedef GpMatrixOrder MatrixOrder
typedef GpFlushIntention FlushIntention
'typedef GpPathData PathData

$endif

